<template>
  <div class="menu-bg" id="menu-bg">
    <mt-header fixed :title="appTitle" class="menu"> 
      <!-- <router-link to="/flowcenter" slot="left">
        <mt-button icon="back"></mt-button>
      </router-link> -->
      <!-- <mt-button icon="back" slot="left" @click="doBack"></mt-button> -->
    </mt-header>
    <div class="spaceHeader"></div>
    <div v-for="menu in menus" :key="menu.id" class="menuCon">
      <div class="menuConBox" v-if="menu.children&&menu.children.length>0">
        <div class="menu-partHeader" >{{menu.description}}</div>
        <div class="menu-flex">
          <template v-if="menu.children">
            <template v-for="(item, j) in menu.children">
              <router-link
                to="/menu"
                @click.native="nav_click(item.actionContent, item)"
                :key="'menu'+j"
              >
                <div class="menu-flexSpan">
                  <div v-if="item.newIco != null && item.newIco.icontype == 'img'" class="icon-wrap">
                    <span class="row-count" v-if="item.totalRow">
                      {{item.totalRow}}
                    </span>
                    <img class="menu-img" :src="contextPath + item.newIco.icon + aToken"/>
                  </div>
                  <div v-if="item.newIco != null && item.newIco.icontype == 'font'" class="icon-wrap">
                    <span class="row-count" v-if="item.totalRow">
                      {{item.totalRow}}
                    </span>
                    <i :class="'menu-font fa-2x '+ item.newIco.icon" :style="{color: item.newIco.iconFontColor}"></i>
                  </div>
                  <div v-if="item.newIco == null" class="icon-wrap">
                    <span class="row-count" v-if="item.totalRow">
                      {{item.totalRow}}
                    </span>
                    <img class="menu-img" src="../assets/images/defaultMenu.png"/>
                  </div>
                  <span class="description">{{item.description}}</span>
                  
                </div>
              </router-link>
            </template>
          </template>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { Toast } from 'mint-ui';
import API from "@/api.js";
import Constant from "@/Constant.js";
export default {
  name: "Menu",
  data: function() {
    return {
      menus: [],
      Constant,
      contextPath:'',
      appTitle:'',
      aToken:'',
    };
  },
  created() {
    this.aToken = "?accessToken=" + localStorage.getItem("accessToken")
    this.contextPath = obpmConfig.obpmFilePath;
    API.getMenus(this.$root.appid, {
      onSucess: response => {
        this.menus = response.data.data;
      }
    });
  },
  activated() {
    let positionY = this.$store.state.scrollY
    let scrollId = document.getElementById("menu-bg")
    if( positionY === 0 ) {
      scrollId.scrollTo(0, 0)
    }else {
      scrollId.scrollTo(0, positionY) //页面激活时控制滚动条滚动到指定的位置
    }
  },
  beforeRouteLeave(to, from, next) {
    // from.meta.keepAlive = true;
    let scrollY = document.getElementById("menu-bg").scrollTop //离开之前记录此时滚动条的位置
    this.$store.commit('saveScrollY', scrollY)
    next();
  },

  methods: {
    doBack() {
      this.$router.go(-1)
    },
    nav_click(viewId, item) {
      //:to="{name:'open', query:{linkType:menu3.linkType,actionContent:menu3.actionContent}}"
      let appId = this.$root.appid;
      let params = {};
      switch (item.linkType) {
        case "00": 
          params = {linkType:'00',actionContent:viewId};
          if(item.queryString) {
            params.queryString = item.queryString;
          }
          this.$router.push({  
            name: 'open',
            query: params
          })
          break;
        case "01": 
          this.$api.hasPermissionToView(appId, viewId, {
            onSucess: response => {
              if(response.data.data) {
                params = {linkType:'01',actionContent:viewId};
                this.$router.push({  
                  name:'open',
                  query:params,
                })
              }else {
                Toast(this.$t('notPermission'))
              }
            }
          });
          break;
        case "02": 
          this.$router.push({  
            name:'chart',
            query:{linkType:'02',actionContent:viewId}
          })
          break;
				case "07": 
          params = {
            linkType:'103', 
            actionContent:viewId, 
            showBack: true
          };
          this.$router.push({  
            name:'open',
            query:params,
          });
		  	break;
        case "09": 
          this.$api.getCustomreports(viewId,
            {
              onSucess: response => {
                let urls = obpmConfig.obpmFilePath + "/" + response.data;
                this.$router.push({  
                  name:'report',
                  query:{linkType:'09', actionContent:viewId, path:urls}
                })
                // if(urls.split("=")[2]) {
                //   let arr = urls.split("=")[2];
                //   if(arr.split(";")[0]) {
                //     let arr2 = arr.split(";")[0];
                //     if(arr2.split("'")[1]) {
                //       let currentUrl = arr2.split("'")[1];
                //       this.$router.push({  
                //         name:'report',
                //         query:{linkType:'09',actionContent:viewId,path:currentUrl}
                //       })
                //     }
                //   }
                // }
              }
            }
          );
          break;
        default:
          break;
      }





      // if(item.linkType == "09") { //报表
      //   this.$router.push({  
      //     name:'report',
      //     query:{linkType:'09',actionContent:viewId}
      //   })
      // }else if(item.linkType == "02") { //图表
      //   this.$router.push({  
      //     name:'chart',
      //     query:{linkType:'02',actionContent:viewId}
      //   })
      // }else {
      //   this.$api.hasPermissionToView(appId, viewId, {
      //     onSucess: response => {
      //       if(response.data.data) {
      //         this.$router.push({  
      //           name:'open',
      //           query:{linkType:'01',actionContent:viewId}
      //         })
      //       }else {
      //         Toast(this.$t('notPermission'))
      //       }
      //     }
      //   })
      // }
    },
    setMenus(arr){
      for(let i=0;i<arr.length;i++) {
        if(arr[i].children && arr[i].children.length>0) {
          this.setMenus(arr[i].children)
        }else {
          if(arr[i].linkType && arr[i].linkType == "00"){
            arr.splice(i, 1);
            i--;
          }
        }
      }
    },
  },
  mounted(){
    this.appTitle=document.title
  },

  watch: {
    menus() {
      // this.setMenus(arr);
      
    },
  },

};
</script>
